TimesToLoop equ 100;00;00;0 ; number of times to loop
include Part1.inc
; -------------------------------------  Timing Tests -----------------------------------

; This is the code to copy to create new timing tests. Copy this code and paste it below.
; Change the X in DoitX to a number (Doit1, Doit2,...Doit99)
DoitX:
    Desc ' ' ;insert description of this test between single quotes
    ; -- place any setup desired here.  Registers will not be preserved into test code --
    BeginCounter    ; place test code here between BeginCounter and EndCounter ----------

    EndCounter      ; end of test code --------------------------------------------------
    ret

;--------------------------------- Test Procs -------------------------------------------

;  Place any test procs or setup/checking procs you wish here
.data
lParamT  dd 00100020h	; 16x32
xWidth  dd ?
yHeight dd ?
.code

Doit1:
    Desc 'mov shift'
    BeginCounter
    mov eax,lParamT  ;**
    mov edx,eax     ;**
    and eax,0ffffh  ;** width
    shr edx,16      ;** height
    mov xWidth,eax
    mov yHeight,edx ;**
    EndCounter
;	mov eax,TestNum
;	add eax,6000
;	inv SetDlgItemInt,hWin,eax,yHeight,0
    
    ret

Doit2:
    Desc 'movzx word ptr'
    BeginCounter
    movzx eax,word ptr lParamT
    mov xWidth,eax
    movzx eax,word ptr [lParamT+2]
    mov yHeight,eax
    EndCounter
;	mov eax,TestNum
;	add eax,6000
;	inv SetDlgItemInt,hWin,eax,yHeight,0
    ret



.data?
hPen      DWORD ?
hBrush    DWORD ?
lb        LOGBRUSH <?>
hctrl dd ?
hDC dd ?
.code   
Doit11:
    Desc 'create pen'
    BeginCounter
    invoke CreatePen,0,1,000000FFh  ; red
    mov hPen, eax
    invoke DeleteObject,hPen
    EndCounter
    ret
   
Doit12:
    Desc 'create brush'
    BeginCounter
    mov lb.lbStyle, BS_SOLID
    mov lb.lbColor, 00FF0000h       ; blue
    mov lb.lbHatch, NULL
    invoke CreateBrushIndirect,ADDR lb
    invoke DeleteObject,hBrush
    EndCounter
    ret
   
Doit13:
    Desc 'getdc/releasedc '
    inv GetDlgItem,hWin,91007
    mov hctrl,eax
    BeginCounter
   	    inv GetDC,hctrl     ; get the DC of the control
	    mov hDC,eax       ; get temp handle to control
	    ;inv BitBlt,htemp,X1,Y1,tw,th,mhDC,X1,Y1,SRCCOPY  ; copy directly to controls bitmap
		inv ReleaseDC,hctrl,hDC
    
    EndCounter
    ret
.data?
lpp POINT <?>
lrr RECT <?>
hPenOld dd ?
hBrushOld dd ?
.code

Doit14:
    Desc 'draw with pen'
    inv GetDlgItem,hWin,91007
    mov hctrl,eax
    inv GetDC,hctrl     ; get the DC of the control
    mov hDC,eax       ; get temp handle to control
    invoke CreatePen,PS_SOLID,1,Cyan
    mov hPen,eax
	inv SelectObject,hDC, hPen	;Associate pen with object
	mov hPenOld,eax
    BeginCounter
		inv MoveToEx,hDC, 0, 12,addr lpp
		inv LineTo,hDC,80,12
    EndCounter
	inv SelectObject,hDC, hPenOld	;restore
	inv ReleaseDC,hctrl,hDC
    invoke DeleteObject,hPen
    ret
   
Doit15:
    Desc 'draw FillRect with brush'
    inv GetDlgItem,hWin,91007
    mov hctrl,eax
    inv GetDC,hctrl     ; get the DC of the control
    mov hDC,eax       ; get temp handle to control
    mov lb.lbStyle, BS_SOLID
    mov lb.lbColor, Red     ; blue
    mov lb.lbHatch, NULL
    invoke CreateBrushIndirect,ADDR lb
    mov hBrush,eax
;	inv SelectObject,hDC, hBrush	;Associate pen with object
;	mov hBrushOld,eax
    BeginCounter
    	mov lrr.RECT.left,0
    	mov lrr.RECT.top,0
    	mov lrr.RECT.right,80
    	mov lrr.RECT.bottom,20
        inv FillRect,hDC,addr lrr,hBrush
    EndCounter
;	inv SelectObject,hDC, hBrushOld	;restore
	inv ReleaseDC,hctrl,hDC
    invoke DeleteObject,hBrush
    ret
   
Doit16:
    Desc 'invoke rectangle'
    inv GetDlgItem,hWin,91007
    mov hctrl,eax
    inv GetDC,hctrl     ; get the DC of the control
    mov hDC,eax       ; get temp handle to control
    mov lb.lbStyle, BS_SOLID
    mov lb.lbColor, Blue    ; blue
    mov lb.lbHatch, NULL
    invoke CreateBrushIndirect,ADDR lb
    mov hBrush,eax
;	inv SelectObject,hDC, hBrush	;Associate pen with object
;	mov hBrushOld,eax
    BeginCounter
    	inv Rectangle,hDC,0,0,80,20
    EndCounter
;	inv SelectObject,hDC, hBrushOld	;restore
	inv ReleaseDC,hctrl,hDC
    invoke DeleteObject,hBrush
    ret
Doit17:
    Desc 'line with FillRect and Brush'
    inv GetDlgItem,hWin,91007
    mov hctrl,eax
    inv GetDC,hctrl     ; get the DC of the control
    mov hDC,eax       ; get temp handle to control
    mov lb.lbStyle, BS_SOLID
    mov lb.lbColor, Green    ; blue
    mov lb.lbHatch, NULL
    invoke CreateBrushIndirect,ADDR lb
    mov hBrush,eax
;	inv SelectObject,hDC, hBrush	;Associate pen with object
;	mov hBrushOld,eax
    BeginCounter
    	mov lrr.RECT.left,0
    	mov lrr.RECT.top,15
    	mov lrr.RECT.right,80
    	mov lrr.RECT.bottom,16
    	inv FillRect,hDC,addr lrr,hBrush
    EndCounter
;	inv SelectObject,hDC, hBrushOld	;restore
	inv ReleaseDC,hctrl,hDC
    invoke DeleteObject,hBrush
    ret
Doit18:
    Desc 'FrameRect'
    inv GetDlgItem,hWin,91007
    mov hctrl,eax
    inv GetDC,hctrl     ; get the DC of the control
    mov hDC,eax       ; get temp handle to control
    mov lb.lbStyle, BS_SOLID
    mov lb.lbColor, Magenta    ; blue
    mov lb.lbHatch, NULL
    invoke CreateBrushIndirect,ADDR lb
    mov hBrush,eax
;	inv SelectObject,hDC, hBrush	;Associate pen with object
;	mov hBrushOld,eax
    BeginCounter
    	mov lrr.RECT.left,0
    	mov lrr.RECT.top,5
    	mov lrr.RECT.right,80
    	mov lrr.RECT.bottom,16
    	inv FrameRect,hDC,addr lrr,hBrush
    EndCounter
;	inv SelectObject,hDC, hBrushOld	;restore
	inv ReleaseDC,hctrl,hDC
    invoke DeleteObject,hBrush
    ret


    
 ;              ------------------------ end of timing tests --------------------
include Part2.inc